<?php
	//饭否论坛签名图 by 洛城东华 Feb.18 2012
	//设定本程序内部编码
	mb_internal_encoding("UTF-8");
	//获得URL中的ID
	$ff_id = $_GET['id'];
	$ff_id = mb_convert_encoding($ff_id, "UTF-8", "gb2312");
	//设定Content Type为PNG
	header("Content-type: image/png");
	//如果有ID
	if($ff_id){
		//获取API远程json数据
		$r_url = 'http://api.fanfou.com/users/show.json?id='.$ff_id;
		$r_json = @file_get_contents($r_url);
		if($r_json <> false){
			//将JSON数据转换为数组
			$r_json = json_decode($r_json, true);
			//如果服务器返回的不是错误信息
			if(!$r_json['error']){
				//指定字体。此处的wqy.ttc为文泉驿正黑
				$font = 'wqy.ttc';
				//新建画布
				$img = imagecreatetruecolor(400,150);
				//将背景图片绘制在画布上
				$img_back = imagecreatefrompng('sigback.png');
				imagecopyresampled($img,$img_back,0,0,0,0,400,150,400,150);
				//分配颜色
				$color_white = imagecolorallocate($img,255,255,255);
				$color_skyblue = imagecolorallocate($img,0,120,255);
				//从JSON数组中读取数据
				$txt_id = $r_json['name']; //屏显名
				$txt_fo = $r_json['friends_count']; //关注数
				$txt_foer = $r_json['followers_count']; //关注者数
				$txt_msgc = $r_json['statuses_count']; //消息数
				$txt_recentmsg = $r_json['status']['text']; //最近一条信息
				if(!$txt_recentmsg || $txt_recentmsg == '') $txt_recentmsg = '我只向关注我的人公开我的消息。'; //没有最近一条信息说明为PP用户
				if(strlen($txt_recentmsg) > 315) $txt_recentmsg = cut_str($txt_recentmsg,105); //大于105字时调用汉字Cut函数进行截断
				$txt_avatar = $r_json['profile_image_url_large']; //Avatar
				if(!$txt_avatar || $txt_avatar == '') $txt_avatar = 'avatar00.jpg'; //容错，没有Avatar信息的场合下显示默认Avatar
				$pic_avatar = imagecreatefromjpeg($txt_avatar); //读入远程Avatar图片
				//开始绘制输出图片
				//调用自定义方法ImageTextOuter绘制描边字
				imagetextouter($img,10,132,33,'#EEFFFF',$font,$txt_id,'#66CCFF');
				//绘制关注（者）数、消息数以及最近消息
				imagettftext($img,9,0,133,53,$color_white,$font,'关注/'.$txt_fo.' '.'关注者/'.$txt_foer.' '.'消息数/'.$txt_msgc);
				imagettftext($img,9,0,131,51,$color_skyblue,$font,'关注/'.$txt_fo.' '.'关注者/'.$txt_foer.' '.'消息数/'.$txt_msgc);
				imagettftext($img,9,0,132,71,$color_white,$font,autowrap(9,0,$font,$txt_recentmsg,260));
				imagettftext($img,9,0,131,70,$color_skyblue,$font,autowrap(9,0,$font,$txt_recentmsg,260));
				//绘制头像
				imagecopy($img,$pic_avatar,20,27,0,0,96,96);
			}else{
				//服务器返回的是错误信息，显示「调用错误」
				$img = imagecreatefrompng('sig500.png');
			}
		}else{
			//获取远程数据失败，显示「调用错误」
			$img = imagecreatefrompng('sig500.png');
		}
	}else{
		//没有指定id参数，显示「没有指定ID」
		$img = imagecreatefrompng('sig404.png');
	}
	//输出绘图结果
	imagepng($img);
	//销毁图片对象释放内存
	imagedestroy($img);
	imagedestroy($img_back);
	exit;

	function autowrap($fontsize, $angle, $fontface, $string, $width) {
	// Autowrap function by NetPuter
	// From: http://orzdream.com/2010/08/auto-wrap-in-php-gd/
	// 这几个变量分别是 字体大小, 角度, 字体名称, 字符串, 预设宽度 
	$content = "";
 
	// 将字符串拆分成一个个单字 保存到数组 letter 中
	for ($i=0;$i<mb_strlen($string);$i++) {
		$letter[] = mb_substr($string, $i, 1);
	}
 
	foreach ($letter as $l) {
		$teststr = $content." ".$l;
		$testbox = imagettfbbox($fontsize, $angle, $fontface, $teststr);
		// 判断拼接后的字符串是否超过预设的宽度
		if (($testbox[2] > $width) && ($content !== "")) {
			$content .= "\n";
		}
		$content .= $l;
	}
	return $content;
	}

	function imagetextouter(&$im, $size, $x, $y, $color, $fontfile, $text, $outer)
	// Image Outerliner
	// From http://www.ugia.cn/?p=88
	{
		if (!function_exists('ImageColorAllocateHEX'))
		{
			function ImageColorAllocateHEX($im, $s)
			{
			   if($s{0} == "#") $s = substr($s,1);
			   $bg_dec = hexdec($s);
			   return imagecolorallocate($im,
						   ($bg_dec & 0xFF0000) >> 16,
						   ($bg_dec & 0x00FF00) >>  8,
						   ($bg_dec & 0x0000FF)
						   );
			}
		}
		$ttf = false;
		if (is_file($fontfile))
		{
			$ttf = true;
			$area = imagettfbbox($size, $angle, $fontfile, $text);
			$width  = $area[2] - $area[0] + 2;
			$height = $area[1] - $area[5] + 2;
		}
		else
		{
			$width  = strlen($text) * 10;
			$height = 16;
		}
		$im_tmp = imagecreate($width, $height);
		$white = imagecolorallocate($im_tmp, 255, 255, 255);
		$black = imagecolorallocate($im_tmp, 0, 0, 0);
		$color = ImageColorAllocateHEX($im, $color);
		$outer = ImageColorAllocateHEX($im, $outer);
		if ($ttf)
		{
			imagettftext($im_tmp, $size, 0, 0, $height - 2, $black, $fontfile, $text);
			imagettftext($im, $size, 0, $x, $y, $color, $fontfile, $text);
			$y = $y - $height + 2;
		}
		else
		{
			imagestring($im_tmp, $size, 0, 0, $text, $black);
			imagestring($im, $size, $x, $y, $text, $color);
		}
		for ($i = 0; $i < $width; $i ++)
		{
			for ($j = 0; $j < $height; $j ++)
			{
				$c = ImageColorAt($im_tmp, $i, $j);
				if ($c !== $white)
				{
					ImageColorAt ($im_tmp, $i, $j - 1) != $white || imagesetpixel($im, $x + $i, $y + $j - 1, $outer);
					ImageColorAt ($im_tmp, $i, $j + 1) != $white || imagesetpixel($im, $x + $i, $y + $j + 1, $outer);
					ImageColorAt ($im_tmp, $i - 1, $j) != $white || imagesetpixel($im, $x + $i - 1, $y + $j, $outer);
					ImageColorAt ($im_tmp, $i + 1, $j) != $white || imagesetpixel($im, $x + $i + 1, $y + $j, $outer);
					ImageColorAt ($im_tmp, $i - 1, $j - 1) != $white || imagesetpixel($im, $x + $i - 1, $y + $j - 1, $outer);
					ImageColorAt ($im_tmp, $i + 1, $j - 1) != $white || imagesetpixel($im, $x + $i + 1, $y + $j - 1, $outer);
					ImageColorAt ($im_tmp, $i - 1, $j + 1) != $white || imagesetpixel($im, $x + $i - 1, $y + $j + 1, $outer);
					ImageColorAt ($im_tmp, $i + 1, $j + 1) != $white || imagesetpixel($im, $x + $i + 1, $y + $j + 1, $outer);
				}
			}
		}
		imagedestroy($im_tmp);
	}

	function cut_str($sourcestr,$cutlength){
		//Double-byted chars substr function
		//From: http://hi.baidu.com/ayu1106/blog/item/b62d73ede57521d7b31cb1c0.html
		$returnstr='';
		$i=0;
		$n=0;
		$str_length=strlen($sourcestr);//字符串的字节数
		while (($n<$cutlength) and ($i<=$str_length)){
		   $temp_str=substr($sourcestr,$i,1);
		   $ascnum=Ord($temp_str);//得到字符串中第$i位字符的ascii码
		   if ($ascnum>=224){ //如果ASCII位高与224，
			$returnstr=$returnstr.substr($sourcestr,$i,3); //根据UTF-8编码规范，将3个连续的字符计为单个字符
			$i=$i+3; //实际Byte计为3
			$n++; //字串长度计1
		   }elseif ($ascnum>=192){ //如果ASCII位高与192，
			$returnstr=$returnstr.substr($sourcestr,$i,2); //根据UTF-8编码规范，将2个连续的字符计为单个字符
			$i=$i+2; //实际Byte计为2
			$n++; //字串长度计1
		   }elseif ($ascnum>=65 && $ascnum<=90){ //如果是大写字母，
			$returnstr=$returnstr.substr($sourcestr,$i,1);
			$i=$i+1; //实际的Byte数仍计1个
			$n++; //但考虑整体美观，大写字母计成一个高位字符
		   }else{ //其他情况下，包括小写字母和半角标点符号，
			$returnstr=$returnstr.substr($sourcestr,$i,1);
			$i=$i+1; //实际的Byte数计1个
			$n=$n+0.5; //小写字母和半角标点等与半个高位字符宽...
		   }
		}
		if ($str_length>$cutlength){
		   $returnstr = $returnstr . "...";//超过长度时在尾处加上省略号
		}
		return $returnstr; 
	}
?>